// mixed.h
// by David Lambert - 2013-02-11

#ifndef MIXED_H
#define MIXED_H

#include <iostream>
using namespace std;

class Mixed
{
	//overloaded operators
	friend ostream& operator<< (ostream& s, const Mixed& m);
	friend istream& operator>> (istream& s, Mixed& m);
	friend Mixed operator+ (const Mixed& m1, const Mixed& m2);
	friend Mixed operator- (const Mixed& m1, const Mixed& m2);
	friend Mixed operator* (const Mixed& m1, const Mixed& m2);
	friend Mixed operator/ (const Mixed& m1, const Mixed& m2);
	friend Mixed operator++ (Mixed& m1);
	friend Mixed operator++ (Mixed& m1, int dummy);
	friend Mixed operator-- (Mixed& m1);
	friend Mixed operator-- (Mixed& m1, int dummy);
	friend bool operator< (const Mixed& m1, const Mixed& m2);
	friend bool operator== (const Mixed& m1, const Mixed& m2);
	friend bool operator<= (const Mixed& m1, const Mixed& m2);
	friend bool operator> (const Mixed& m1, const Mixed& m2);
	friend bool operator>= (const Mixed& m1, const Mixed& m2);
	friend bool operator!= (const Mixed& m1, const Mixed& m2);

public:
	Mixed(int w = 0);		//default (and conversion) constructor
	Mixed(int w, int n, int d);	//constructor w/ parameters

	//accessors
	double Evaluate() const;	//convert mixed # to decimal
	
	//mutators
	void Simplify();
	void ToFraction();

private:
	bool Set(int, int, int);	//Function to assist setting the mixed #
	
	//member data
	int whole;
	int numerator;
	int denominator;
};

#endif
